SystemOrganization addCategory: #SystemAnnouncements!
SystemOrganization addCategory: #'SystemAnnouncements-Tests'!

TestCase subclass: #SAAnnouncementCreationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemAnnouncements-Tests'!

!SAAnnouncementCreationTest methodsFor: 'testing' stamp: 'StephaneDucasse 8/10/2011 08:43'!
testAnnouncementHasTimeStamp
	self assert: ((AddedEvent classCategory: 'XXX') asSystemAnnouncement timeStamp <= TimeStamp current)! !

!SAAnnouncementCreationTest methodsFor: 'testing' stamp: 'StephaneDucasse 10/12/2011 18:10'!
testCategoryAddedAnnouncement
	self assert: ((AddedEvent classCategory: 'XXX') asSystemAnnouncement isKindOf: SystemCategoryAddedAnnouncement)! !

!SAAnnouncementCreationTest methodsFor: 'testing' stamp: 'StephaneDucasse 10/12/2011 18:11'!
testCategoryRemovedAnnouncement
	self assert: ((RemovedEvent classCategory: 'XXX') asSystemAnnouncement isKindOf: SystemCategoryRemovedAnnouncement)! !

!SAAnnouncementCreationTest methodsFor: 'testing' stamp: 'StephaneDucasse 10/12/2011 18:11'!
testCategoryRenamedAnnouncement
	self assert: ((RenamedEvent
					classCategoryRenamedFrom: 'anOldClassCategoryName' 
					to: 'aNewClassCategoryName')  asSystemAnnouncement isKindOf: SystemCategoryRenamedAnnouncement)! !

!SAAnnouncementCreationTest methodsFor: 'testing' stamp: 'StephaneDucasse 10/12/2011 18:11'!
testClassAddedAnnouncement
	self assert: ((AddedEvent class: Object category: 'XXX')  asSystemAnnouncement isKindOf: SystemClassAddedAnnouncement)! !

!SAAnnouncementCreationTest methodsFor: 'testing' stamp: 'StephaneDucasse 10/12/2011 18:11'!
testClassCommentedAnnouncement
	self assert: ((CommentedEvent class: Object)  asSystemAnnouncement isKindOf: SystemClassCommentedAnnouncement)! !

!SAAnnouncementCreationTest methodsFor: 'testing' stamp: 'StephaneDucasse 10/12/2011 18:12'!
testClassCommentedAnnouncement2
	self assert: ((CommentedEvent class: self class oldComment: 'oldComment' newComment: 'newComment' oldStamp: DateAndTime now newStamp: DateAndTime now)  asSystemAnnouncement isKindOf: SystemClassCommentedAnnouncement)! !

!SAAnnouncementCreationTest methodsFor: 'testing' stamp: 'StephaneDucasse 10/12/2011 18:12'!
testClassRecategorizedAnnouncement
	self assert: ((RecategorizedEvent 
				class: self class
				category: 'newCategory'
				oldCategory: 'oldCategory')  asSystemAnnouncement isKindOf: SystemClassRecategorizedAnnouncement)! !

!SAAnnouncementCreationTest methodsFor: 'testing' stamp: 'StephaneDucasse 10/12/2011 18:12'!
testClassRemovedAnnouncement
	self assert: ((RemovedEvent class: Object category: 'XXX')  asSystemAnnouncement isKindOf: SystemClassRemovedAnnouncement)! !

!SAAnnouncementCreationTest methodsFor: 'testing' stamp: 'StephaneDucasse 10/12/2011 18:22'!
testClassRenamedAnnouncement
	self assert: ((RenamedEvent 
				class: self class
				category: 'aCategoryName'
				oldName: 'oldClassName'
				newName: 'NewClassName')  asSystemAnnouncement isKindOf: SystemClassRenamedAnnouncement)! !

!SAAnnouncementCreationTest methodsFor: 'testing' stamp: 'StephaneDucasse 10/12/2011 18:23'!
testClassReorganizedAnnouncement
	self assert: ((ReorganizedEvent 
				class: self class)  asSystemAnnouncement isKindOf: SystemClassReorganizedAnnouncement)! !

!SAAnnouncementCreationTest methodsFor: 'testing' stamp: 'StephaneDucasse 10/12/2011 18:23'!
testMethodAddedAnnouncement
	self assert: ((AddedEvent
				method: self class >> #testMethodAddedAnnouncement
				selector: #testMethodAddedAnnouncement
				class: self class)  asSystemAnnouncement isKindOf: SystemMethodAddedAnnouncement)! !

!SAAnnouncementCreationTest methodsFor: 'testing' stamp: 'StephaneDucasse 10/12/2011 18:23'!
testMethodAddedAnnouncement2
	self assert: ((AddedEvent
				method: self class >> #testMethodAddedAnnouncement
				selector: #testMethodAddedAnnouncement
				protocol: 'protocol'
				class: self class)  asSystemAnnouncement isKindOf: SystemMethodAddedAnnouncement)! !

!SAAnnouncementCreationTest methodsFor: 'testing' stamp: 'StephaneDucasse 10/12/2011 18:23'!
testMethodModifiedAnnouncement
	self assert: (((ModifiedMethodEvent
					methodChangedFrom: self class >> #testMethodModifiedAnnouncement
					to: self class >> #testMethodModifiedAnnouncement
					selector: 'testMethodModifiedAnnouncement' 
					inClass: self class
					requestor: nil)
					oldProtocol: 'oldProtocol';
					newProtocol: 'newProtocol') asSystemAnnouncement isKindOf: SystemMethodModifiedAnnouncement) ! !

!SAAnnouncementCreationTest methodsFor: 'testing' stamp: 'StephaneDucasse 10/12/2011 18:44'!
testMethodModifiedAnnouncement2
	self assert: ((ModifiedEvent
					methodChangedFrom: self class >> #testMethodModifiedAnnouncement2
					to: self class >> #testMethodModifiedAnnouncement
					selector: 'testMethodModifiedAnnouncement2'
					inClass: self class
					requestor: nil) asSystemAnnouncement isKindOf: SystemMethodModifiedAnnouncement) ! !

!SAAnnouncementCreationTest methodsFor: 'testing' stamp: 'StephaneDucasse 10/12/2011 18:45'!
testMethodModifiedAnnouncement3
	self assert: ((ModifiedEvent
					methodChangedFrom: self class >> #testMethodModifiedAnnouncement2
					to: self class >> #testMethodModifiedAnnouncement
					selector: 'testMethodModifiedAnnouncement2'
					inClass: self class) asSystemAnnouncement isKindOf: SystemMethodModifiedAnnouncement) ! !

!SAAnnouncementCreationTest methodsFor: 'testing' stamp: 'StephaneDucasse 10/12/2011 19:01'!
testMethodRecategorizedAnnouncement
	self assert: (((RecategorizedEvent 
					method: (self class >> #testMethodRecategorizedAnnouncement) 
					protocol: 'newCategory' 
					class: self class) oldCategory:  'oldCategory'
					)  asSystemAnnouncement isKindOf: SystemMethodRecategorizedAnnouncement)! !

!SAAnnouncementCreationTest methodsFor: 'testing' stamp: 'StephaneDucasse 10/12/2011 19:01'!
testMethodRemovedAnnouncement
	self assert: ((RemovedEvent
				method: self class >> #testMethodAddedAnnouncement
				selector: #testMethodAddedAnnouncement
				class: self class)  asSystemAnnouncement isKindOf: SystemMethodRemovedAnnouncement)! !

!SAAnnouncementCreationTest methodsFor: 'testing' stamp: 'StephaneDucasse 10/12/2011 19:01'!
testMethodRemovedAnnouncement2
	self assert: ((RemovedEvent
				method: self class >> #testMethodAddedAnnouncement
				selector: #testMethodAddedAnnouncement
				protocol: 'protocol'
				class: self class)  asSystemAnnouncement isKindOf: SystemMethodRemovedAnnouncement)! !

!SAAnnouncementCreationTest methodsFor: 'testing' stamp: 'StephaneDucasse 10/12/2011 19:01'!
testMethodRenamedAnnouncement
	self assert: ((RenamedEvent 
				class: self class
				category: 'aCategoryName'
				oldName: 'oldClassName'
				newName: 'NewClassName')  asSystemAnnouncement isKindOf: SystemClassRenamedAnnouncement)! !

TestCase subclass: #SACategoryAnnouncementTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemAnnouncements-Tests'!

!SACategoryAnnouncementTest commentStamp: 'cyrilledelaunay 1/18/2011 15:19' prior: 0!
This class provide several test checking that any modification on categories, made in the system, will emit the right annoucement. !

!SACategoryAnnouncementTest methodsFor: 'accessing' stamp: 'StephaneDucasse 10/12/2011 23:03'!
announcer
	^ SystemAnnouncer announcer! !

!SACategoryAnnouncementTest methodsFor: 'tests' stamp: 'StephaneDucasse 10/12/2011 19:01'!
testAddedCategory
	"self debug: #testAddedCategory"
	"test that when we add a category (using SystemDictionary>> addCategory), the SystemCategoryAddedAnnouncement is correctly emitted"
	| addedCount addedCat | 
	[
		addedCount := 0.
		self announcer when: SystemCategoryAddedAnnouncement do: [ :ann | 
			self deny: ann timeStamp isNil.
			addedCount := addedCount + 1. 
			addedCat := ann event item].
		Smalltalk organization addCategory: 'XXXXX'.
		self assert: addedCat = 'XXXXX'.
		self assert: addedCount = 1.
	] ensure: [
		"we clean"
		|mCPackage|
		self announcer unsubscribe: self.
		Smalltalk organization removeCategory: 'XXXXX'.
		mCPackage := (MCWorkingCopy allManagers detect: [:each | each packageName = 'XXXXX'] ifNone: [nil]) .
		mCPackage ifNotNil: [mCPackage unregister]. 
		self flag: #cyrille. "why do we have to do that: it means that MC does not handle well the removal of category. so we should fix it?"
		
		
		]! !

!SACategoryAnnouncementTest methodsFor: 'tests' stamp: 'StephaneDucasse 10/12/2011 19:02'!
testRemovedCategory
	"test that when we remove a category (using SystemDictionary>> removeCategory:), the SystemCategoryRemovedAnnouncement is correctly emitted"
	| count addedCat | 
	[
		count := 0.
		addedCat := ''.
		Smalltalk organization addCategory: 'XXXXX'.
		self announcer when: SystemCategoryRemovedAnnouncement do: [ :ann | 
			count := count + 1 ].
		Smalltalk organization removeCategory: 'XXXXX' .
		self assert: count = 1.
	] ensure: [
		"we clean"
		|mCPackage|
		self announcer unsubscribe: self.
		Smalltalk organization removeCategory: 'XXXXX'.
		mCPackage := (MCWorkingCopy allManagers detect: [:each | each packageName = 'XXXXX'] ifNone: [nil]) .
		mCPackage ifNotNil: [mCPackage unregister].
		 ]! !

!SACategoryAnnouncementTest methodsFor: 'tests' stamp: 'StephaneDucasse 10/12/2011 19:02'!
testRenamedCategory
	"self debug: #testRenamedCategory"
	"test that when we rename a category (using SystemDictionary>> renameCategory:), the SystemCategoryRenamedAnnouncement is correctly emitted"
	| newCategory oldCategory | 
	[
		self announcer when: SystemCategoryRenamedAnnouncement do: [ :ann | 
			newCategory := ann newName.
			oldCategory := ann oldName.].
		Smalltalk organization addCategory: 'XXXXX'.
		Smalltalk organization renameCategory: 'XXXXX' toBe: 'YY'.
		self assert: newCategory = 'YY'.
		self assert: oldCategory = 'XXXXX'.
	] ensure: [
		"we clean"
		|mCPackage|
		self announcer unsubscribe: self.
		Smalltalk organization removeCategory: 'XXXXX'.
		Smalltalk organization removeCategory: 'YY'. 
		mCPackage := (MCWorkingCopy allManagers detect: [:each | each packageName = 'XXXXX'] ifNone: [nil]) .
		mCPackage ifNotNil: [mCPackage unregister].
		mCPackage := (MCWorkingCopy allManagers detect: [:each | each packageName = 'YY'] ifNone: [nil]) .
		mCPackage ifNotNil: [mCPackage unregister].
		]! !

TestCase subclass: #SAClassAnnouncementTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemAnnouncements-Tests'!

!SAClassAnnouncementTest commentStamp: 'cyrilledelaunay 1/18/2011 15:19' prior: 0!
This class provide several test checking that any modification on classes, made in the system, will emit the right annoucement. !

!SAClassAnnouncementTest methodsFor: 'accessing' stamp: 'StephaneDucasse 10/12/2011 23:03'!
announcer
	^ SystemAnnouncer announcer! !

!SAClassAnnouncementTest methodsFor: 'setup' stamp: 'StephaneDucasse 8/10/2011 22:49'!
tearDown

	Smalltalk globals organization removeCategory: 'Unclassified'! !

!SAClassAnnouncementTest methodsFor: 'tests' stamp: 'StephaneDucasse 10/12/2011 19:03'!
testAddProtocolShouldEmitClassReorganizedAnnouncement
	
	"test that when we add a protocol to a class, the systemClassReorganizedAnnouncement is correctly emitted"
	| count class | 
	[
		count := 0.
		class := Object subclass: #XXXX.
		self announcer when: SystemClassReorganizedAnnouncement do: [ :ann | 
			count := count + 1. ].
		class organization addCategory: 'new-protocol' before: nil.
		self assert: count = 1.
	] ensure: [
		"we clean"
		self announcer unsubscribe: self.
		class removeFromSystem
		 ]! !

!SAClassAnnouncementTest methodsFor: 'tests' stamp: 'StephaneDucasse 10/12/2011 19:03'!
testAddedClass
	"test that when create a new class, the SystemClassAddedAnnouncement is correctly emitted"
	|class count | 
	[
		count := 0.
		self announcer when: SystemClassAddedAnnouncement do: [ :ann | 
			count := count + 1. ].
		class := Object subclass: #XXXX.
		self assert: count = 1.
	] ensure: [
		"we clean"
		self announcer unsubscribe: self.
		class removeFromSystem
		 ]! !

!SAClassAnnouncementTest methodsFor: 'tests' stamp: 'StephaneDucasse 10/12/2011 19:04'!
testAddedTrait
	"test that when create a new trait, the SystemClassAddedAnnouncement is correctly emitted"
	|trait count | 
	[
		count := 0.
		self announcer when: SystemClassAddedAnnouncement do: [ :ann | 
			count := count + 1. ].
		trait := Trait named: #XXXX.
		self assert: count = 1.
	] ensure: [
		"we clean"
		self announcer unsubscribe: self.
		trait removeFromSystem
		 ]! !

!SAClassAnnouncementTest methodsFor: 'tests' stamp: 'StephaneDucasse 10/12/2011 19:03'!
testRecategorizedClass
	"self debug: #testRecategorizedClass"
	"test that when we set a new category to a class, SystemClassRecategorizedAnnouncement is correctly emitted"
	| class newCat oldCat itemClass |
	[
		class := Object subclass: #XXXX
			instanceVariableNames: '' 
			classVariableNames: '' 
			poolDictionaries: '' 
			category: 'OriginalCategory'.
		self haltIf: [
			"something's wrong here"
			class category = nil
			].
		self announcer when: SystemClassRecategorizedAnnouncement do: [ :ann | 
			newCat := ann newCategory.
			oldCat := ann oldCategory.
			itemClass := ann itemClass.
			 ].
		class category: 'Y'.
		self assert: newCat  = 'Y'.
		self assert: oldCat = 'OriginalCategory'.
		self assert: itemClass = (Smalltalk at: #XXXX).
	] ensure: [
		"we clean"
		|mCPackage|
		self announcer unsubscribe: self.
		class removeFromSystem.
		Smalltalk organization removeCategory: 'Y'.
		Smalltalk organization removeCategory: 'OriginalCategory'.
		mCPackage := (MCWorkingCopy allManagers detect: [:each | each packageName = 'Y'] ifNone: [nil]) .
		mCPackage ifNotNil: [mCPackage unregister].
		mCPackage := (MCWorkingCopy allManagers detect: [:each | each packageName = 'OriginalCategory'] ifNone: [nil]) .
		mCPackage ifNotNil: [mCPackage unregister].
		 ]! !

!SAClassAnnouncementTest methodsFor: 'tests' stamp: 'StephaneDucasse 10/12/2011 19:03'!
testRecategorizedTrait
	"self debug: #testRecategorizedTrait"
	"test that when we set a new category to a trait, SystemClassRecategorizedAnnouncement is correctly emitted"
	| trait newCat oldCat itemClass |
	[
		trait := Trait named: #XXXX asSymbol
			uses: {}
			category: 'OldCategoryName'.
		self haltIf: [
			"something's wrong here"
			trait category = nil
			].
		self announcer when: SystemClassRecategorizedAnnouncement do: [ :ann | 
			newCat := ann newCategory.
			oldCat := ann oldCategory.
			itemClass := ann itemClass.
			 ].
		trait category: 'Y'.
		self assert: newCat  = 'Y'.
		self assert: oldCat = 'OldCategoryName'.
		self assert: itemClass = (Smalltalk at: #XXXX).
	] ensure: [
		"we clean"
		|mCPackage|
		self announcer unsubscribe: self.
		trait removeFromSystem.
		Smalltalk organization removeCategory: 'OldCategoryName'.
		Smalltalk organization removeCategory: 'Y'.
		mCPackage := (MCWorkingCopy allManagers detect: [:each | each packageName = 'OldCategoryName'] ifNone: [nil]) .
		mCPackage ifNotNil: [mCPackage unregister].
		mCPackage := (MCWorkingCopy allManagers detect: [:each | each packageName = 'Y'] ifNone: [nil]) .
		mCPackage ifNotNil: [mCPackage unregister].
	
		 ]! !

!SAClassAnnouncementTest methodsFor: 'tests' stamp: 'StephaneDucasse 10/12/2011 19:03'!
testRemoveProtocolShouldEmitClassReorganizedAnnouncement

	"test that when we remove a protocol of a class, the systemClassReorganizedAnnouncement is correctly emitted"
	| count class | 
	[
		count := 0.
		class := Object subclass: #XXXX.
		class organization addCategory: 'new-protocol' before: nil.
		self announcer when: SystemClassReorganizedAnnouncement do: [ :ann | 
			count := count + 1. ].
		class removeCategory: 'new-protocol'.
		self assert: count = 1.
	] ensure: [
		"we clean"
		self announcer unsubscribe: self.
		class removeFromSystem
		 ]! !

!SAClassAnnouncementTest methodsFor: 'tests' stamp: 'StephaneDucasse 10/12/2011 19:04'!
testRemovedCategory
	| count | 
	[
		count := 0.
		Smalltalk organization addCategory: 'XXXXX'.
		self announcer when: SystemCategoryRemovedAnnouncement do: [ :ann | 
			count := count + 1 ].
		Smalltalk organization removeCategory: 'XXXXX' .
		self assert: count = 1.
	] ensure: [
		"we clean"
		|mCPackage|
		self announcer unsubscribe: self.
		Smalltalk organization removeCategory: 'XXXXX'.
		mCPackage := (MCWorkingCopy allManagers detect: [:each | each packageName = 'XXXXX'] ifNone: [nil]) .
		mCPackage ifNotNil: [mCPackage unregister].
		 ]! !

!SAClassAnnouncementTest methodsFor: 'tests' stamp: 'StephaneDucasse 10/12/2011 19:04'!
testRemovedClass
	"test that when we removed a class, SystemClassRemovedAnnouncement is correctly emitted"
	| count class | 
	[
		count := 0.
		class := Object subclass: #XXXX.
		self announcer when: SystemClassRemovedAnnouncement do: [ :ann | 
			count := count + 1. ].
		class removeFromSystem.
		self assert: count = 1.
	] ensure: [
		"we clean"
		self announcer unsubscribe: self ]! !

!SAClassAnnouncementTest methodsFor: 'tests' stamp: 'StephaneDucasse 10/12/2011 19:04'!
testRemovedTrait
	"test that when we removed a trait, SystemClassRemovedAnnouncement is correctly emitted"
	| count trait | 
	[
		count := 0.
		trait := Trait named: #XXXX.
		self announcer when: SystemClassRemovedAnnouncement do: [ :ann | 
			count := count + 1. ].
		trait removeFromSystem.
		self assert: count = 1.
	] ensure: [
		"we clean"
		self announcer unsubscribe: self ]! !

!SAClassAnnouncementTest methodsFor: 'tests' stamp: 'StephaneDucasse 10/12/2011 19:05'!
testRenameProtocolShouldEmitClassReorganizedAnnouncement
	"test that when we rename a protocol of a class, the systemClassReorganizedAnnouncement is correctly emitted"
	| count class | 
	[
		count := 0.
		class := Object subclass: #XXXX.
		class organization addCategory: 'old-protocol' before: nil.
		self announcer when: SystemClassReorganizedAnnouncement do: [ :ann | 
			count := count + 1. ].
		class organization renameCategory: 'old-protocol' toBe: 'new-protocol'.
		self assert: count = 1.
	] ensure: [
		"we clean"
		self announcer unsubscribe: self.
		class removeFromSystem
		 ]! !

!SAClassAnnouncementTest methodsFor: 'tests' stamp: 'StephaneDucasse 10/12/2011 19:05'!
testRenamedClass
	"test that when we rename a class (using class >> rename:), SystemClassRenamedAnnouncement is correctly emitted"
	| count class | 
	[
		count := 0.
		class := Object subclass: 'TestRenamedClassInitialName' asSymbol.
		self announcer when: SystemClassRenamedAnnouncement do: [ :ann | 
			count := count + 1. ].
		class rename: 'TestRenamedClassNewName'.
		self assert: count = 1.
	] ensure: [
		"we clean"
		self flag: #cyrille. "should we not unsubscribe after to give a chance to the system to react and for
		example update itself."
		self announcer unsubscribe: self.
		class removeFromSystem ]! !

!SAClassAnnouncementTest methodsFor: 'tests' stamp: 'StephaneDucasse 10/12/2011 19:11'!
testRenamedTrait
	"test that when we rename a trait (using Trait >> rename:), SystemClassRenamedAnnouncement is correctly emitted"
	| count trait | 
	[
		count := 0.
		trait := Trait named: 'TestRenamedTraitInitialName' asSymbol.
		self announcer when: SystemClassRenamedAnnouncement do: [ :ann | 
			count := count + 1. ].
		trait rename: 'TestRenamedTraitNewName'.
		self assert: count = 1.
	] ensure: [
		"we clean"
		self announcer unsubscribe: self.
		trait removeFromSystem ]! !

!SAClassAnnouncementTest methodsFor: 'tests' stamp: 'StephaneDucasse 10/12/2011 19:12'!
testSortProtocolsInATraitShouldEmitClassReorganizedAnnouncement
	"test that when we sort the protocols (and if this sort concretly modify the order of protocols) of a class, the systemClassReorganizedAnnouncement is correctly emitted"
	| count trait | 
	[
		count := 0.
		trait := Trait named: #XXXX.
		trait organization addCategory: 'a' before: nil.
		trait organization addCategory: 'b' before: 'a'.
		self announcer when: SystemClassReorganizedAnnouncement do: [ :ann | 
			count := count + 1. ].
		trait organization sortCategories.
		self assert: count = 1.
	] ensure: [
		"we clean"
		self announcer unsubscribe: self.
		trait removeFromSystem
		 ]! !

!SAClassAnnouncementTest methodsFor: 'tests' stamp: 'StephaneDucasse 10/12/2011 19:12'!
testSortProtocolsShouldEmitClassReorganizedAnnouncement
	"test that when we sort the protocols (and if this sort concretly modify the order of protocols) of a class, the systemClassReorganizedAnnouncement is correctly emitted"
	| count class | 
	[
		count := 0.
		class := Object subclass: #XXXX.
		class organization addCategory: 'a' before: nil.
		class organization addCategory: 'b' before: 'a'.
		self announcer when: SystemClassReorganizedAnnouncement do: [ :ann | 
			count := count + 1. ].
		class organization sortCategories.
		self assert: count = 1.
	] ensure: [
		"we clean"
		self announcer unsubscribe: self.
		class removeFromSystem
		 ]! !

TestCase subclass: #SAMethodAnnouncementTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemAnnouncements-Tests'!

!SAMethodAnnouncementTest commentStamp: 'cyrilledelaunay 1/18/2011 15:19' prior: 0!
This class provide several test checking that any modification on method, made in the system, will emit the right annoucement. !

!SAMethodAnnouncementTest methodsFor: 'accessing' stamp: 'StephaneDucasse 10/12/2011 23:03'!
announcer
	^ SystemAnnouncer announcer! !

!SAMethodAnnouncementTest methodsFor: 'tests' stamp: 'StephaneDucasse 8/10/2011 21:45'!
setUp

	Smalltalk globals organization removeCategory: 'Unclassified'! !

!SAMethodAnnouncementTest methodsFor: 'tests' stamp: 'StephaneDucasse 8/10/2011 21:45'!
tearDown

	Smalltalk globals organization removeCategory: 'Unclassified'! !

!SAMethodAnnouncementTest methodsFor: 'tests' stamp: 'StephaneDucasse 10/12/2011 19:12'!
testAddedMethod
	"self debug: #testAddedMethod"
	"test that when we add a method to a class, the SystemMethodAddedAnnouncement is correctly emitted"
	| count protocol selector class | 
	[
		count := 0.
		Object subclass: #XXXX.
		"here we set the action to execute when the announcement is emited"
		self announcer when: SystemMethodAddedAnnouncement do: [ :ann | 
			count := count + 1. 
			protocol := ann  itemProtocol.
			selector := ann itemSelector.
			class := ann itemClass].
		(Smalltalk globals at: #XXXX) compile: 'm ^ 1' classified: 'protocol'.
		self assert: count = 1.
		self assert: protocol = 'protocol'.
		self assert: selector = #m.
		self assert: class = (Smalltalk globals at: #XXXX).
	] ensure: [
		"we clean"
		self announcer unsubscribe: self.
		(Smalltalk globals at: #XXXX) theNonMetaClass removeFromSystem ]! !

!SAMethodAnnouncementTest methodsFor: 'tests' stamp: 'StephaneDucasse 10/12/2011 19:13'!
testAddedMethodInTrait
	"self debug: #testAddedMethodInTrait"
	"test that when we add a method to a class, the SystemMethodAddedAnnouncement is correctly emitted"
	| count protocol selector class methodTrait | 
	[
		count := 0.
		methodTrait := Trait named: #XXXX.
		"here we set the action to execute when the announcement is emited"
		self announcer when: SystemMethodAddedAnnouncement do: [ :ann | 
			count := count + 1. 
			protocol := ann  itemProtocol.
			selector := ann itemSelector.
			class := ann itemClass].
		methodTrait compile: 'm ^ 1' classified: 'protocol'.
		self assert: count = 1.
		self assert: protocol = 'protocol'.
		self assert: selector = #m.
		self assert: class = (Smalltalk globals at: #XXXX).
	] ensure: [
		"we clean"
		self announcer unsubscribe: self.
		methodTrait removeFromSystem ]! !

!SAMethodAnnouncementTest methodsFor: 'tests' stamp: 'StephaneDucasse 10/12/2011 19:13'!
testModifiedMethod
	"self debug: #testModifiedMethod"
	"test that when we re-compile an existing method in a class, the SystemMethodModifiedAnnouncement is correctly emited. If the method does not yet exist in the class, the event will not be emited "
	| count newProtocol oldProtocol selector methodClass class | 
	[
		count := 0.
		methodClass := Object subclass: #XXXX.
		methodClass compile: 'm ^ 1' classified: 'protocol'.
		"here we set the action to execute when the announcement is emited"
		self announcer when: SystemMethodModifiedAnnouncement do: [ :ann |
			count := count + 1. 
			newProtocol := ann itemNewProtocol.
			oldProtocol := ann itemOldProtocol. 
			selector := ann itemSelector.
			class := ann itemClass
			].
		"here we re-compile the methos and check that the announcement has been well caught"
		methodClass compile: 'm ^ 2' classified: 'new-protocol'.
		self assert: count = 1.
		self assert: oldProtocol = 'protocol'.
		self assert: newProtocol = 'new-protocol'.
		self assert: selector = #m.
		self assert: class = methodClass.
	] ensure: [
		"we clean"
		self announcer unsubscribe: self.
		(Smalltalk globals at: #XXXX) theNonMetaClass removeFromSystem ]! !

!SAMethodAnnouncementTest methodsFor: 'tests' stamp: 'StephaneDucasse 10/12/2011 19:13'!
testModifiedMethodInTrait
	"self debug: #testModifiedMethodInTrait"
	"test that when we re-compile an existing method in a trrait, the SystemMethodModifiedAnnouncement is correctly emited. If the method does not yet exist in the trait, the event will not be emited "
	| count newProtocol oldProtocol selector methodTrait class | 
	[
		count := 0.
		methodTrait := Trait named: 'XXXXX' asSymbol.
		methodTrait compile: 'm ^ 1' classified: 'protocol'.
		"here we set the action to execute when the announcement is emited"
		self announcer when: SystemMethodModifiedAnnouncement do: [ :ann |
			count := count + 1. 
			newProtocol := ann itemNewProtocol.
			oldProtocol := ann itemOldProtocol. 
			selector := ann itemSelector.
			class := ann itemClass
			].
		methodTrait compile: 'm ^ 2' classified: 'new-protocol'.
		self assert: count = 1.
		self assert: oldProtocol = 'protocol'.
		self assert: newProtocol = 'new-protocol'.
		self assert: selector = #m.
		self assert: class = methodTrait.
	] ensure: [
		"we clean"
		self announcer unsubscribe: self.
		methodTrait theNonMetaClass removeFromSystem ]! !

!SAMethodAnnouncementTest methodsFor: 'tests' stamp: 'StephaneDucasse 10/12/2011 19:15'!
testRecategorizedMethod
	"self debug: #testRecategorizedMethod"
	"test that when we RE-categorized a method from a class under a new protocol, SystemMethodRecategorizedAnnouncement is correctly emitted. If the method is classify under its current protocol, the announcement will not be emitted"
	| count newProtocol selector methodClass class oldProtocol |
	[
		count := 0.
		methodClass := Object subclass: #XXXX.
		methodClass compile: 'm ^ 1' classified: 'protocol'.
		"here we set the action to execute when the announcement is emited"
		self announcer when: SystemMethodRecategorizedAnnouncement do: [ :ann | 
			count := count + 1.
			newProtocol := ann  itemNewProtocol.
			oldProtocol := ann itemOldProtocol.
			selector := ann itemSelector.
			class := ann itemClass ].
		"here we put the method in a new protocol, and check  that the announcement has been correctly caught"
		methodClass organization classify: #m under: 'new protocol'.
		self assert: count = 1.
		self assert: newProtocol = 'new protocol' asSymbol.
		self assert: oldProtocol = 'protocol' asSymbol.
		self assert: selector = #m.
		self assert: class = (Smalltalk globals at: #XXXX).
	] ensure: [
		"we clean"
		self announcer unsubscribe: self.
		(Smalltalk at: #XXXX) theNonMetaClass removeFromSystem ]! !

!SAMethodAnnouncementTest methodsFor: 'tests' stamp: 'StephaneDucasse 10/12/2011 19:22'!
testRecategorizedMethodByRemovingMethodFromOrganizer
	"self debug: #testRecategorizedMethodByRemovingMethodFromOrganizer"
	"test that when we remove a method from a class or a trait organizer, SystemMethodRecategorizedAnnouncement is correctly emitted. I don't know exactly when this case could happen"
	| count newProtocol selector methodClass class oldProtocol |
	[
		count := 0.
		methodClass := Object subclass: #XXXX.
		methodClass compile: 'm ^ 1' classified: 'protocol'.
		"here we set the action to execute when the announcement is emited"
		self announcer when: SystemMethodRecategorizedAnnouncement do: [ :ann | 
			count := count + 1.
			newProtocol := ann  itemNewProtocol.
			oldProtocol := ann itemOldProtocol.
			selector := ann itemSelector.
			class := ann itemClass ].
		"here we put the method in a new protocol, and check  that the announcement has been correctly caught"
		methodClass organization removeElement: #m.
		self assert: count = 1.
		self assert: newProtocol = nil.
		self assert: oldProtocol = 'protocol' asSymbol.
		self assert: selector = #m.
		self assert: class = (Smalltalk at: #XXXX).
	] ensure: [
		"we clean"
		self announcer unsubscribe: self.
		(Smalltalk globals at: #XXXX) theNonMetaClass removeFromSystem ]! !

!SAMethodAnnouncementTest methodsFor: 'tests' stamp: 'StephaneDucasse 10/12/2011 19:16'!
testRecategorizedMethodByRenamingProtocol
	"self debug: #testRecategorizedMethodByRenamingProtocol"
	"test that when we rename a non-empty protocol from a class, SystemMethodRecategorizedAnnouncement is correctly emitted. If the protocol does not contain any method, the announcement will not be emitted"
	| count newProtocol selector methodClass class oldProtocol |
	[
		count := 0.
		methodClass := Object subclass: #XXXX.
		methodClass compile: 'm ^ 1' classified: 'protocol'.
		"here we set the action to execute when the announcement is emited"
		self announcer when: SystemMethodRecategorizedAnnouncement do: [ :ann | 
			count := count + 1.
			newProtocol := ann  itemNewProtocol.
			oldProtocol := ann itemOldProtocol.
			selector := ann itemSelector.
			class := ann itemClass ].
		"here we put the method in a new protocol, and check  that the announcement has been correctly caught"
		methodClass organization renameCategory: 'protocol' toBe: 'new protocol'.
		self assert: count = 1.
		self assert: newProtocol = 'new protocol' asSymbol.
		self assert: oldProtocol = 'protocol' asSymbol.
		self assert: selector = #m.
		self assert: class = (Smalltalk globals at: #XXXX).
	] ensure: [
		"we clean"
		self announcer unsubscribe: self.
		(Smalltalk globals at: #XXXX) theNonMetaClass removeFromSystem ]! !

!SAMethodAnnouncementTest methodsFor: 'tests' stamp: 'StephaneDucasse 10/12/2011 19:16'!
testRecategorizedMethodByRenamingProtocolInTrait
	"self debug: #testRecategorizedMethodByRenamingProtocolInTrait"
	"test that when we rename a non-empty protocol from a trait, SystemMethodRecategorizedAnnouncement is correctly emitted. If the protocol does not contain any method, the announcement will not be emitted"
	| count newProtocol selector methodTrait class oldProtocol |
	[
		count := 0.
		methodTrait := Object subclass: #XXXX.
		methodTrait compile: 'm ^ 1' classified: 'protocol'.
		"here we set the action to execute when the announcement is emited"
		self announcer when: SystemMethodRecategorizedAnnouncement do: [ :ann | 
			count := count + 1.
			newProtocol := ann  itemNewProtocol.
			oldProtocol := ann itemOldProtocol.
			selector := ann itemSelector.
			class := ann itemClass ].
		"here we put the method in a new protocol, and check  that the announcement has been correctly caught"
		methodTrait organization renameCategory: 'protocol' toBe: 'new protocol'.
		self assert: count = 1.
		self assert: newProtocol = 'new protocol' asSymbol.
		self assert: oldProtocol = 'protocol' asSymbol.
		self assert: selector = #m.
		self assert: class = (Smalltalk globals at: #XXXX).
	] ensure: [
		"we clean"
		self announcer unsubscribe: self.
		methodTrait removeFromSystem ]! !

!SAMethodAnnouncementTest methodsFor: 'tests' stamp: 'StephaneDucasse 10/12/2011 19:16'!
testRecategorizedMethodInTrait
	"self debug: #testRecategorizedMethodInTrait"
	"test that when we RE-categorized a method from a class under a new protocol, SystemMethodRecategorizedAnnouncement is correctly emitted. If the method is classify under its current protocol, the announcement will not be emitted"
	| count newProtocol selector methodTrait class oldProtocol |
	[
		count := 0.
		methodTrait := Object subclass: #XXXX.
		methodTrait compile: 'm ^ 1' classified: 'protocol'.
		"here we set the action to execute when the announcement is emited"
		self announcer when: SystemMethodRecategorizedAnnouncement do: [ :ann | 
			count := count + 1.
			newProtocol := ann  itemNewProtocol.
			oldProtocol := ann itemOldProtocol.
			selector := ann itemSelector.
			class := ann itemClass ].
		"here we put the method in a new protocol, and check  that the announcement has been correctly caught"
		methodTrait organization classify: #m under: 'new protocol'.
		self assert: count = 1.
		self assert: newProtocol = 'new protocol' asSymbol.
		self assert: oldProtocol = 'protocol' asSymbol.
		self assert: selector = #m.
		self assert: class = (Smalltalk globals at: #XXXX).
	] ensure: [
		"we clean"
		self announcer unsubscribe: self.
		methodTrait removeFromSystem ]! !

!SAMethodAnnouncementTest methodsFor: 'tests' stamp: 'StephaneDucasse 10/12/2011 19:17'!
testRemovedMethod
	"self debug: #testRemovedMethod"
	"test that when a method is removed from a class, SystemMethodRemovedAnnouncement is correctly emitted"
	| count protocol selector class | 
	[
		count := 0.
		Object subclass: #XXXX.
		(Smalltalk at: #XXXX) compile: 'm ^ 1' classified: 'protocol'.
		"here we set the action to execute when the announcement is emited"
		self announcer when: SystemMethodRemovedAnnouncement do: [ :ann | 
			count := count + 1.
			protocol := ann  itemProtocol.
			selector := ann itemSelector.
			class := ann itemClass ].
		"we remove the method and check that the announcement has been correctly caught"
		(Smalltalk at: #XXXX) removeSelector: #m.
		self assert: count = 1.
		self assert: protocol = 'protocol'.
		self assert: selector = #m.
		self assert: class = (Smalltalk globals at: #XXXX).
	] ensure: [
		"we clean"
		self announcer unsubscribe: self.
		(Smalltalk globals at: #XXXX) theNonMetaClass removeFromSystem ]! !

!SAMethodAnnouncementTest methodsFor: 'tests' stamp: 'StephaneDucasse 10/12/2011 19:17'!
testRemovedMethodInTrait
	"self debug: #testRemovedMethodInTrait"
	"test that when a method is removed from a trait, SystemMethodRemovedAnnouncement is correctly emitted"
	| count protocol selector class methodTrait | 
	[
		count := 0.
		methodTrait := Trait named: #XXXX.
		methodTrait compile: 'm ^ 1' classified: 'protocol'.
		"here we set the action to execute when the announcement is emited"
		self announcer when: SystemMethodRemovedAnnouncement do: [ :ann | 
			count := count + 1.
			protocol := ann  itemProtocol.
			selector := ann itemSelector.
			class := ann itemClass ].
		"we remove the method and check that the announcement has been correctly caught"
		methodTrait removeSelector: #m.
		self assert: count = 1.
		self assert: protocol = 'protocol'.
		self assert: selector = #m.
		self assert: class = (Smalltalk globals at: #XXXX).
	] ensure: [
		"we clean"
		self announcer unsubscribe: self.
		methodTrait removeFromSystem ]! !

TestCase subclass: #SAProtocolAnnouncementTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemAnnouncements-Tests'!

!SAProtocolAnnouncementTest commentStamp: 'cyrilledelaunay 1/18/2011 15:19' prior: 0!
This class provide several test checking that any modification on protocols, made in the system, will emit the right annoucement. !

!SAProtocolAnnouncementTest methodsFor: 'accessing' stamp: 'StephaneDucasse 10/12/2011 23:04'!
announcer
	^ SystemAnnouncer announcer! !

!SAProtocolAnnouncementTest methodsFor: 'tests' stamp: 'StephaneDucasse 10/12/2011 19:17'!
testAddedProtocol
	"self debug: #testAddedProtocol"
	"the action of adding a protocol is handle by the SystemClassReorganizedAnnouncement announcement (and not by SystemProtocolAddedAnnouncement). Test that this annoucment is correctly emitted"
	| addedCount class | 
	[
		addedCount := 0.
		self announcer when: SystemClassReorganizedAnnouncement do: [ :ann | 
			addedCount := addedCount + 1.
			class := ann itemClass ].
		self class organization addCategory: 'protocol - addition'.
		self assert: addedCount = 1.
		self assert: class = self class.
	] ensure: [
		"we clean"
		self announcer unsubscribe: self.
		self class organization removeCategory: 'protocol - addition' ]! !

!SAProtocolAnnouncementTest methodsFor: 'tests' stamp: 'StephaneDucasse 10/12/2011 19:20'!
testRemovedProtocol
	"self debug: #testRemovedProtocol"
	"the action of removing a protocol is handle by the SystemClassReorganizedAnnouncement announcement (and not by SystemProtocolRemovedAnnouncement). Test that this annoucment is correctly emitted"
	| removedCount class | 
	[
		removedCount := 0.
		self class organization addCategory: 'protocol - removal'.
		self announcer when: SystemClassReorganizedAnnouncement do: [ :ann | 
			removedCount := removedCount + 1.
			class := ann itemClass ].
		self class organization removeCategory: 'protocol - removal'.
		self assert: removedCount = 1.
		self assert: class = self class.
	] ensure: [
		"we clean"
		self announcer unsubscribe: self.
		self class organization removeCategory: 'protocol - removal'
		]! !

!SAProtocolAnnouncementTest methodsFor: 'tests' stamp: 'StephaneDucasse 10/12/2011 19:21'!
testRenamedProtocol
	"self debug: #testRenamedProtocol"
	"the action of renaming a protocol is handled by the SystemClassReorganizedAnnouncement announcement. Test that this announcement is correctly emitted"
	| renamedCount class | 
	[
		renamedCount := 0.
		self class organization addCategory: 'protocol old name'.
		self announcer when: SystemClassReorganizedAnnouncement do: [ :ann | 
			renamedCount := renamedCount + 1.
			class := ann itemClass ].
		self class organization renameCategory: 'protocol old name' toBe: 'protocol new name'.
		self assert: renamedCount = 1.
		self assert: class = self class.
	] ensure: [
		"we clean"
		self announcer unsubscribe: self.
		self class organization removeCategory: 'protocol old name'.
		self class organization removeCategory: 'protocol new name'
		]! !

Announcer subclass: #SystemAnnouncer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemAnnouncements'!

SystemAnnouncer class
	instanceVariableNames: 'announcer privateAnnouncer'!

!SystemAnnouncer commentStamp: '<historical>' prior: 0!
This class plays the role of the announcer for events raised by the Pharo system.

Currently, it acts as a wrapper over the SystemChangeNotifier, but in the future it should be used for announcing the events directly from the system.!

SystemAnnouncer class
	instanceVariableNames: 'announcer privateAnnouncer'!

!SystemAnnouncer class methodsFor: 'private' stamp: 'StephaneDucasse 10/12/2011 19:39'!
announceFromEvent: aChangeEvent
	"This method creates an announcement from a given Event (subclass of AbstractEvent) and announces it.
	
	For example, from an AddedEvent that concerns a class the method creates SystemAddedClassAnnouncement and then it will announce it both from the generic announcer and from the classAnnouncer "
	| announcement |
	announcement := aChangeEvent asSystemAnnouncement.
	self privateAnnouncer announce: announcement.		
	self announcer announce: announcement.! !

!SystemAnnouncer class methodsFor: 'accessing' stamp: 'StephaneDucasse 10/12/2011 14:56'!
announcer
	"Answer a system annoncer."

	^ announcer ifNil: [ announcer := Announcer new ]! !

!SystemAnnouncer class methodsFor: 'accessing' stamp: 'IgorStasenko 8/12/2011 14:33'!
current
	"Answer a system annoncer."
	
	^ announcer ifNil: [ announcer := Announcer new ]! !

!SystemAnnouncer class methodsFor: 'utilities' stamp: 'StephaneDucasse 10/12/2011 14:57'!
defaultPreferredAnnouncementClassForEvent: aChangeEvent

	| itemKindName eventKindName announcementClassName announcementClass |
	itemKindName := aChangeEvent itemKind.
	eventKindName := (aChangeEvent class name endsWith: 'Event') 
		ifTrue: [ aChangeEvent class name copyFrom: 1 to: aChangeEvent class name size - 'Event' size ] 
		ifFalse: [ aChangeEvent class name ].
	announcementClassName := 	(
										'System', 
										itemKindName capitalized, 
										eventKindName,
										'Announcement'
									) asSymbol.
	announcementClass := Smalltalk at: announcementClassName ifAbsent: [nil].
	^ announcementClass! !

!SystemAnnouncer class methodsFor: 'initialization' stamp: 'StephaneDucasse 10/12/2011 23:05'!
initialize
	"self initialize"
	
	SystemChangeNotifier uniqueInstance 
		notify: self ofAllSystemChangesUsing: #announceFromEvent:! !

!SystemAnnouncer class methodsFor: 'accessing' stamp: 'StephaneDucasse 10/12/2011 14:56'!
privateAnnouncer
	"Answer a system annoncer."

	^ privateAnnouncer ifNil: [ privateAnnouncer := Announcer new ]! !

!SystemAnnouncer class methodsFor: 'initialization' stamp: 'lr 2/22/2010 11:10'!
unload
	SystemChangeNotifier uniqueInstance 
		noMoreNotificationsFor: self! !

!SystemAnnouncer class methodsFor: 'utilities' stamp: 'StephaneDucasse 10/16/2011 18:52'!
unsubscribe: anObject
	"unsubscribe an object from my public/private announcers"
	
	self current unsubscribe: anObject.
	self privateAnnouncer unsubscribe: anObject! !

!ReorganizedEvent methodsFor: '*SystemAnnouncements' stamp: 'StephaneDucasse 7/15/2010 23:19'!
category

	^self itemCategory! !

!ModifiedMethodEvent methodsFor: '*systemannouncements' stamp: 'StephaneDucasse 10/12/2011 18:44'!
asSystemAnnouncement
	^ SystemMethodModifiedAnnouncement new event: self! !

!AbstractEvent methodsFor: '*systemannouncements' stamp: 'StephaneDucasse 10/12/2011 15:10'!
asSystemAnnouncement
	| itemKindName eventKindName announcementClassName announcementClass |
	itemKindName := self itemKind.
	eventKindName := (self class name endsWith: 'Event') 
		ifTrue: [ self class name copyFrom: 1 to: self class name size - 'Event' size ] 
		ifFalse: [ self class name ].
	announcementClassName := 	(
										'System', 
										itemKindName capitalized, 
										eventKindName,
										'Announcement'
									) asSymbol.
	announcementClass := Smalltalk at: announcementClassName ifAbsent: [nil].
	^ announcementClass isNil 
		ifTrue: [ SystemUnknownAnnouncement new ]
		ifFalse: [announcementClass new event: self]! !

Announcement subclass: #SystemAnnouncement
	instanceVariableNames: 'event timeStamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemAnnouncements'!

!SystemAnnouncement commentStamp: '<historical>' prior: 0!
The root announcement for the events coming from the Pharo system.

Currently, it wraps the event that comes from the SystemChangeNotifier.!

!SystemAnnouncement class methodsFor: 'instance creation' stamp: 'StephaneDucasse 4/13/2011 17:03'!
fromInternal: anInternalAnnouncement
	"create a new announcement from an internal announcement. Copy the variables"
	
	| instance |
	self flag: #ben. "why copy does not work?"
	instance := self new.
	1 to: self allInstVarNames size do:[:i | instance instVarAt: i put: ( anInternalAnnouncement instVarAt: i )].
	^ instance! !

!SystemAnnouncement class methodsFor: 'instance creation' stamp: 'StephaneDucasse 8/9/2011 23:05'!
new 
	
	^ super new setTimeStamp; yourself! !

!SystemAnnouncement methodsFor: 'private' stamp: 'tg 6/5/2010 12:17'!
event
	^ event! !

!SystemAnnouncement methodsFor: 'private' stamp: 'tg 6/5/2010 12:17'!
event: anObject
	event := anObject! !

!SystemAnnouncement methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 4/1/2011 17:18'!
item

	^ self event item! !

!SystemAnnouncement methodsFor: 'private' stamp: 'StephaneDucasse 8/9/2011 23:05'!
setTimeStamp

	timeStamp := TimeStamp current.! !

!SystemAnnouncement methodsFor: 'accessing' stamp: 'StephaneDucasse 8/9/2011 23:04'!
timeStamp

	^ timeStamp! !

!SystemAnnouncement methodsFor: 'accessing' stamp: 'StephaneDucasse 8/9/2011 23:04'!
timeStamp: aTimeStamp

	timeStamp := aTimeStamp! !

SystemAnnouncement subclass: #SystemCategoryAddedAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemAnnouncements'!

!SystemCategoryAddedAnnouncement commentStamp: 'cyrilledelaunay 1/18/2011 12:29' prior: 0!
This announcement will be emited when adding a category using:
=> SystemOrganizer >> addCategory:!

!SystemCategoryAddedAnnouncement methodsFor: 'accessing' stamp: 'StephaneDucasse 10/12/2011 15:12'!
categoryName

	^ self item! !

!SystemCategoryAddedAnnouncement methodsFor: 'accessing' stamp: 'StephaneDucasse 7/28/2010 10:34'!
item
	^ event item! !

SystemAnnouncement subclass: #SystemCategoryRemovedAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemAnnouncements'!

!SystemCategoryRemovedAnnouncement commentStamp: 'cyrilledelaunay 1/18/2011 12:28' prior: 0!
This announcement will be emited when removing a category using:
=> SystemOrganizer >> removeCategory:!

!SystemCategoryRemovedAnnouncement methodsFor: 'accessing' stamp: 'StephaneDucasse 10/12/2011 15:12'!
categoryName

	^ self  item! !

!SystemCategoryRemovedAnnouncement methodsFor: 'accessing' stamp: 'StephaneDucasse 10/12/2011 15:12'!
categorySelector

	^ self item asSymbol! !

SystemAnnouncement subclass: #SystemCategoryRenamedAnnouncement
	instanceVariableNames: 'from to'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemAnnouncements'!

!SystemCategoryRenamedAnnouncement commentStamp: 'cyrilledelaunay 1/18/2011 12:26' prior: 0!
This announcement will be emited when renaming a category using:
=> SystemOrganizer >> renameCategory:toBe:!

!SystemCategoryRenamedAnnouncement methodsFor: 'accessing' stamp: 'StephaneDucasse 7/27/2010 21:59'!
newName

	^ event newName! !

!SystemCategoryRenamedAnnouncement methodsFor: 'accessing' stamp: 'StephaneDucasse 7/27/2010 21:59'!
oldName

	^ event oldName! !

!SystemCategoryRenamedAnnouncement methodsFor: 'accessing' stamp: 'StephaneDucasse 10/12/2011 15:14'!
oldNameSymbol

	^ event oldName asSymbol! !

SystemAnnouncement subclass: #SystemClassAddedAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemAnnouncements'!

!SystemClassAddedAnnouncement commentStamp: 'cyrilledelaunay 1/18/2011 11:56' prior: 0!
This announcement will be emitted when a class or a trait is added, using:
	=> Trait >> named: (the notification is done in Trait >> named:uses:category:env:)
	=> Class >> subclass:
	!

!SystemClassAddedAnnouncement methodsFor: 'accessing' stamp: 'StephaneDucasse 10/12/2011 15:15'!
itemClass

	^ self item ! !

!SystemClassAddedAnnouncement methodsFor: 'accessing' stamp: 'StephaneDucasse 10/12/2011 15:15'!
itemClassSymbol

	^ self itemClass theNonMetaClass name asSymbol! !

SystemAnnouncement subclass: #SystemClassCommentedAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemAnnouncements'!

SystemAnnouncement subclass: #SystemClassRecategorizedAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemAnnouncements'!

!SystemClassRecategorizedAnnouncement commentStamp: 'cyrilledelaunay 1/18/2011 10:42' prior: 0!
This announcement will be raised when:
- we set a category to a class (see 'Class >>category:')
- we set a category to a Trait (see Trait>>category:)

It corresponds to the RecategorizedEvent!

!SystemClassRecategorizedAnnouncement methodsFor: 'as yet unclassified' stamp: 'StephaneDucasse 7/27/2010 22:38'!
itemClass 

	^ event itemClass ! !

!SystemClassRecategorizedAnnouncement methodsFor: 'as yet unclassified' stamp: 'StephaneDucasse 7/28/2010 09:09'!
newCategory 

	^ event itemCategory ! !

!SystemClassRecategorizedAnnouncement methodsFor: 'as yet unclassified' stamp: 'StephaneDucasse 4/24/2011 18:24'!
oldCategory 

	^ event oldCategory asSymbol! !

SystemAnnouncement subclass: #SystemClassRemovedAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemAnnouncements'!

!SystemClassRemovedAnnouncement commentStamp: 'cyrilledelaunay 1/18/2011 11:43' prior: 0!
the annoucement will be emitted when removing a class or a trait using:  
	=> removeFromSystem!

!SystemClassRemovedAnnouncement methodsFor: 'accessing' stamp: 'StephaneDucasse 10/12/2011 15:15'!
removedClass

	^ self item class! !

!SystemClassRemovedAnnouncement methodsFor: 'accessing' stamp: 'StephaneDucasse 10/12/2011 15:15'!
removedClassCategory

	^ self item class theNonMetaClass category! !

SystemAnnouncement subclass: #SystemClassRenamedAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemAnnouncements'!

!SystemClassRenamedAnnouncement commentStamp: 'cyrilledelaunay 1/18/2011 11:44' prior: 0!
the annoucement will be emitted when renaming a class or a trait using:  
	=> RenameClassRefactoring >> rename:to:
	=> class>>rename:
The corresponding event is raised in: SystemDictionary>>renameClass:from:to:!

!SystemClassRenamedAnnouncement methodsFor: 'accessing' stamp: 'StephaneDucasse 10/12/2011 15:16'!
itemClass

	^ self item! !

!SystemClassRenamedAnnouncement methodsFor: 'accessing' stamp: 'StephaneDucasse 10/12/2011 15:16'!
itemPackageName
	"It cannot be self itemClass package name since itemClass refer to the new class which is not in
	the current RPackageOrganizer - because we are currently in the process of rename it.
	
	It cannot be  (Smalltalk globals at: self oldName) package name because oldName class is not anymore in Smalltalk globals."
	^ self event itemCategory
	! !

!SystemClassRenamedAnnouncement methodsFor: 'accessing' stamp: 'StephaneDucasse 10/12/2011 15:16'!
newName
	
	^ self event newName! !

!SystemClassRenamedAnnouncement methodsFor: 'accessing' stamp: 'StephaneDucasse 10/12/2011 15:16'!
oldName
	
	^ self event oldName! !

SystemAnnouncement subclass: #SystemClassReorganizedAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemAnnouncements'!

!SystemClassReorganizedAnnouncement commentStamp: 'cyrilledelaunay 1/18/2011 15:03' prior: 0!
This announcement corresponds to the ReorganizedEvent, which seems to (by looking at the references of ReorganizedEvent) be raised when:
- we rename a protocol (see 'renameCategory:toBe: '). if The category is not empty, SystemMethodRecategorizedAnnouncement will also be emitted
- we sort (modify the order of) protocols (see 'sortCategories')
- we add a protocol (see 'addCategory:before:')
- we remove a protocol (see 'removeCategory:' 'removeEmptyCategories')!

!SystemClassReorganizedAnnouncement methodsFor: 'accessing' stamp: 'StephaneDucasse 10/12/2011 15:16'!
itemClass

	^ self item! !

SystemAnnouncement subclass: #SystemMethodAddedAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemAnnouncements'!

!SystemMethodAddedAnnouncement commentStamp: 'cyrilledelaunay 1/18/2011 13:06' prior: 0!
This announcement is emited when we add a method to a class or a trait using:
	=> Behavior >> compile: or TraitBehavior >> compile:!

!SystemMethodAddedAnnouncement methodsFor: 'accessing' stamp: 'StephaneDucasse 7/16/2010 13:08'!
itemClass

	^ event itemClass
	! !

!SystemMethodAddedAnnouncement methodsFor: 'accessing' stamp: 'StephaneDucasse 10/12/2011 15:17'!
itemMethod

	^ self item! !

!SystemMethodAddedAnnouncement methodsFor: 'accessing' stamp: 'StephaneDucasse 7/16/2010 13:08'!
itemProtocol

	^ event itemProtocol! !

!SystemMethodAddedAnnouncement methodsFor: 'accessing' stamp: 'StephaneDucasse 7/16/2010 13:08'!
itemSelector

	^ event itemSelector
	! !

SystemAnnouncement subclass: #SystemMethodModifiedAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemAnnouncements'!

!SystemMethodModifiedAnnouncement commentStamp: 'BenjaminVanRyseghem 4/1/2011 16:04' prior: 0!
This announcement is emited when we RE-compile a method in a class or a trait, with: ClassDescription >> compile: or TraitDescription >> compile:. If the method is not yet registered in the class or the trait, the announcement will not be emitted.

The action of renaming a method will be handled by SystemMethodRemovedAnnouncement and SystemMethodAddedAnnouncement, since this refactoring is concretely composed by removing the old method and add a new with the new name  !

!SystemMethodModifiedAnnouncement methodsFor: 'accessing' stamp: 'StephaneDucasse 10/12/2011 15:17'!
item

	^ event item! !

!SystemMethodModifiedAnnouncement methodsFor: 'accessing' stamp: 'cyrilledelaunay 1/17/2011 14:45'!
itemClass

	^ event itemClass
	! !

!SystemMethodModifiedAnnouncement methodsFor: 'accessing' stamp: 'cyrilledelaunay 1/18/2011 13:50'!
itemNewProtocol

	^ event newProtocol! !

!SystemMethodModifiedAnnouncement methodsFor: 'accessing' stamp: 'cyrilledelaunay 1/18/2011 13:50'!
itemOldProtocol

	^ event oldProtocol! !

!SystemMethodModifiedAnnouncement methodsFor: 'accessing' stamp: 'cyrilledelaunay 1/17/2011 14:44'!
itemProtocol

	^ event itemProtocol! !

!SystemMethodModifiedAnnouncement methodsFor: 'accessing' stamp: 'cyrilledelaunay 1/17/2011 14:45'!
itemSelector

	^ event itemSelector
	! !

!SystemMethodModifiedAnnouncement methodsFor: 'accessing' stamp: 'StephaneDucasse 10/12/2011 15:17'!
newMethod

	^ event oldItem! !

!SystemMethodModifiedAnnouncement methodsFor: 'accessing' stamp: 'StephaneDucasse 10/12/2011 15:17'!
oldItem

	^ event oldItem! !

!SystemMethodModifiedAnnouncement methodsFor: 'accessing' stamp: 'StephaneDucasse 10/12/2011 15:17'!
oldMethod
	
	^ self  item! !

SystemAnnouncement subclass: #SystemMethodRecategorizedAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemAnnouncements'!

!SystemMethodRecategorizedAnnouncement commentStamp: 'cyrilledelaunay 1/18/2011 15:03' prior: 0!
This announcement will be emitted when:
	=> a non-empty protocol is renamed in a class or a trait (using ClassOrganizer >> renameCategory:toBe:). If the protocol does not contain any method, the announcement will not be emitted. Therefore, if we rename a non-empty protocol, both SystemMethodRecategorizedAnnouncement and SystemClassReorganizedAnnouncement will be emitted
	=> a method is removed from a category of a class or a trait (using ClassOrganizer >> removeElement:)
	=> a method is RE-categorized in a protocol of a trait or a class, using Organizer>>classify:under:.  If the method is classify under its current protocol, the announcement will not be emitted!

!SystemMethodRecategorizedAnnouncement methodsFor: 'accessing' stamp: 'cyrilledelaunay 1/17/2011 15:40'!
itemClass

	^ event itemClass
	! !

!SystemMethodRecategorizedAnnouncement methodsFor: 'accessing' stamp: 'cyrilledelaunay 1/17/2011 16:14'!
itemNewProtocol

	^ event itemProtocol! !

!SystemMethodRecategorizedAnnouncement methodsFor: 'accessing' stamp: 'cyrilledelaunay 1/17/2011 16:11'!
itemOldProtocol

	^ event oldCategory! !

!SystemMethodRecategorizedAnnouncement methodsFor: 'accessing' stamp: 'cyrilledelaunay 1/17/2011 15:41'!
itemSelector

	^ event itemSelector
	! !

SystemAnnouncement subclass: #SystemMethodRemovedAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemAnnouncements'!

!SystemMethodRemovedAnnouncement commentStamp: 'cyrilledelaunay 1/18/2011 14:43' prior: 0!
This announcement will be emitted when a method is removed from a trait or a class, 
using ClassDescription >>removeSelector: or TraitDescription >> removeSelector.
!

!SystemMethodRemovedAnnouncement methodsFor: 'accessing' stamp: 'StephaneDucasse 4/13/2011 21:23'!
itemClass

	^ self event itemClass
	! !

!SystemMethodRemovedAnnouncement methodsFor: 'accessing' stamp: 'StephaneDucasse 10/12/2011 15:18'!
itemMethod

	^ event item
	! !

!SystemMethodRemovedAnnouncement methodsFor: 'accessing' stamp: 'StephaneDucasse 4/13/2011 21:23'!
itemProtocol

	^ self event itemProtocol! !

!SystemMethodRemovedAnnouncement methodsFor: 'accessing' stamp: 'StephaneDucasse 4/13/2011 21:23'!
itemSelector

	^ self event itemSelector
	! !

SystemAnnouncement subclass: #SystemProtocolAddedAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemAnnouncements'!

!SystemProtocolAddedAnnouncement commentStamp: '<historical>' prior: 0!
This class is not used, but should be used when we hook into the addition and removal of protocols. Right now, we only get ClassReorganizedAnnouncement!

SystemAnnouncement subclass: #SystemProtocolRemovedAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemAnnouncements'!

!SystemProtocolRemovedAnnouncement commentStamp: '<historical>' prior: 0!
This class is not used, but should be used when we hook into the addition and removal of protocols. Right now, we only get ClassReorganizedAnnouncement!

SystemAnnouncement subclass: #SystemUnknownAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemAnnouncements'!

Object subclass: #AnnouncementLogger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemAnnouncements'!

!AnnouncementLogger commentStamp: 'StephaneDucasse 5/9/2011 17:17' prior: 0!
Use me to debug and log to the transcript annoncements.


AnnouncementLogger new subscribeTo: SystemAnnouncer announcer

To unsubscribe

AnnouncementLogger  allInstancesDo: [:each | SystemAnnouncer announcer unsubscribe: each ]!

!AnnouncementLogger methodsFor: 'as yet unclassified' stamp: 'StephaneDucasse 5/9/2011 17:11'!
logAnnouncement: ann

	Transcript show: ann printString ; cr! !

!AnnouncementLogger methodsFor: 'as yet unclassified' stamp: 'StephaneDucasse 5/9/2011 17:15'!
subscribeTo: anAnnouncer

	anAnnouncer "weak" 
		on: Announcement send: #logAnnouncement: to: self! !
SystemAnnouncer initialize!
